// Copyright (c) 2023 Proton AG
//
// This file is part of Proton Mail Bridge.
//
// Proton Mail Bridge is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Proton Mail Bridge is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Proton Mail Bridge.  If not, see <https://www.gnu.org/licenses/>.

package tests

import (
	"crypto/x509"

	"github.com/ProtonMail/proton-bridge/v3/internal/certs"
)

var (
	preCompCertPEM []byte
	preCompKeyPEM  []byte
)

func FastGenerateCert(template *x509.Certificate) ([]byte, []byte, error) {
	return preCompCertPEM, preCompKeyPEM, nil
}

func init() {
	template, err := certs.NewTLSTemplate()
	if err != nil {
		panic(err)
	}

	certPEM, keyPEM, err := certs.GenerateCert(template)
	if err != nil {
		panic(err)
	}

	preCompCertPEM = certPEM
	preCompKeyPEM = keyPEM
}
